
(* backtracking enumeration *)

(* sets of cells *)
module Cells : sig
  type t 
  val empty : t
  val add : int -> int -> t -> t
  val mem : int -> int -> t -> bool
  val remove : int -> int -> t -> t
  val iter : (int -> int -> unit) -> t -> unit
end

val iter : 
  (Board.t -> unit) -> 
  draw:(int -> int -> Puzzle.piece -> unit) ->
  clear:(int -> int -> unit) ->
  choose:(Board.t -> Cells.t -> int * int * Pset.t) ->
  Board.t -> 
  Cells.t -> 
  unit

val choose_mincard : Board.t -> Cells.t -> int * int * Pset.t

val enum : Board.t -> Cells.t -> int

