
(* the persistent state of the board *)

open Puzzle

type t

val score : t -> int

val todo  : t -> int

val avail : t -> int Parray.t

val empty : t

val initial : t
  (* empty board with piece 139 placed if [is_eternity_ii] *)

val create : complete:bool -> piece array array -> t

exception Incorrect
exception Incomplete

val place : complete:bool -> t -> int -> int -> piece -> t

val poss : t -> int -> int -> Pset.t

val piece_at : t -> int -> int -> piece

val iter_empty : (int -> int -> unit) -> t -> unit

val save : t -> string -> unit 

