
(* the board, simple version *)

open Puzzle0

module TileSet : Set.S with type elt = tile

type t = { 
  board : (tile * int) Pmatrix.t; 
  (* matrix n*n with a tile and an orientation *)
  remaining_corners : TileSet.t; (* unplaced tiles *)
  remaining_edges : TileSet.t; (* unplaced tiles *)
  remaining_others : TileSet.t; (* unplaced tiles *)
  todo  : int; (* number of empty cells *)
  score : int; (* score *)
}

val empty : unit -> t

val initial : t
  (* empty board with tile 139 placed if [is_eternity_ii] *)

val create : (int*int) array array -> t

val get : t -> int -> int -> tile * int

val put : t -> int -> int -> tile -> int -> t

val remove : t -> int -> int -> t

val score_delta : t -> int -> int -> tile -> int -> int

val load : string -> t
val save : t -> string -> unit 

