
open Format
open Brute7

(*
let iteratively_expand_tree first_tile first_rot b =
  let time = ref (Unix.time ()) in
  while true do
    b := expand_tree_root init_board first_tile first_rot !b;
    let n = size !b in
    report_iteration !b;
    let t = Unix.time () in
    if t -. !time > 3600.0 (* 60 minutes *) then
      begin
	let f = "dump_" ^ (string_of_int first_tile) ^ "_" 
	  ^ (string_of_int first_rot) ^ "_" ^(string_of_int n) in
	dump_tree (Filename.concat sol_dir f) !b;
	printf "saved dump file %s@." f;
	time := t;
      end;
  done
*)

let current_tree = ref (init_tree ())

let stats_answer id n server m =
  match m with
    | Msg m -> 
	printf "Serveur id=%d, name=%s, answer: %s@." id n m
    | Status(tile,rot,score,size) ->
	printf "Serveur id=%d, name=%s, tile=%d, rot=%d, score=%d, size=%d@." 
	  id n tile rot score size

let port = ref 2007
let server_name = ""

let servers = Hashtbl.create 7

let server_id_counter = ref 0

let () =
  while true do
    printf "-------------------------------@.";
    printf "1) connect to a new server@.";
    printf "2) show list of servers@.";
    printf "3) show current tree@.";
    printf "4) send computation to a serveur@.";
    let s = read_line() in
    match s with
      | "1" ->
	  printf "serveur name or IP:@.";
	  let n = read_line() in
	  let n = if n="" then "localhost" else n in
	  let server = Network.connection ~machine:server_name ~port:!port in
	  incr server_id_counter;
	  Hashtbl.add servers !server_id_counter (n,server)
      | "2" ->
	  Hashtbl.iter 
	    (fun id (n,server) ->
	       Network.send server Stats;
	       Network.receive (stats_answer id n server) server ~timeout:(-1.0))
	    servers
      | "3" ->
	  display_stats ~prof:0 !current_tree
      | "4" ->
	  begin
	    try
	      printf "serveur number,tile,rot:@.";
	      Scanf.scanf "%d,%d,%d" 
		(fun id tile rot ->
		   let (n,server) = Hashtbl.find servers id in
		   printf "send computation for (%d,%d) to serveur '%s'@." 
		     tile rot n;
		   Network.send server (Compute(!current_tree,tile,rot)))
	    with _ -> 
	      printf "failed to send computation"
	  end
	  
      | _ -> 
	  printf "unknown choice: %s" s
  done
(*
  try
    while true do 
    done
  with Network.Shutdown ->
    eprintf "server closed; bye\n"
*)
      
