
open Format
open Brute7

(* main launch *)
  
let () =
  let b = ref (init_tree ())in
  List.iter
    (fun f -> 
       printf "Reading dump file %s...@." f;
       let t = read_tree f in
       printf "Merging...@.";
       b := merge !b t;
       printf "Done.@.")
    merge_files;
  if merge_files <> [] then
    begin
      let f = "merged_" ^ (string_of_int (size !b)) in
      dump_tree (Filename.concat sol_dir f) !b;
      printf "saved merged dump file %s@." f;
    end ;
  let time = ref (Unix.time ()) in
  report_iteration !b;
  if stats >= 0 then begin display_stats ~prof:stats !b; printf "@." end
  else
    while true do
      b := 
	if first_tile <> 0 then
	  expand_tree_root init_board first_tile first_rot !b
	else
	  expand_tree init_board !b;
      let n = size !b in
      report_iteration !b;
      let t = Unix.time () in
      if t -. !time > 36000.0 (* 10 hours *) then
	begin
	  let f = "dump_" ^ (string_of_int first_tile) ^ "_" 
	    ^ (string_of_int first_rot) ^ "_" ^(string_of_int n) in
	  dump_tree (Filename.concat sol_dir f) !b;
	  printf "saved dump file %s@." f;
	  time := t;
	end;
    done

