
open Format
open Puzzle
open Backt

let todo =
  List.fold_left
    (fun s (i,j) -> Cells.add i j s)
    Cells.empty
    [2,2; 2,3; 2,4;
     3,2;      3,4;
     4,2; 4,3; 4,4]

let test p =
  printf "piece %d: @?" p.id;
  let b = Board.place ~complete:true Board.initial 3 3 p in
  try
    let count = ref 0 in
    iter 
      (fun _ -> incr count; if !count = 101 then raise Exit)
      (fun _ _ _ -> ()) (fun _ _ -> ())
      choose_mincard
      b todo;
    printf "count = %d@." !count
  with Exit ->
    printf "count > 100 @."

let () =
  Array.iter
    (fun p -> if p.id != 139 then test p)
    others_rot0

