
(* Persistent arrays *)

type 'a t

val create : int -> 'a -> 'a t

val init : int -> (int -> 'a) -> 'a t

val length : 'a t -> int

val get : 'a t -> int -> 'a

val set : 'a t -> int -> 'a -> 'a t

val to_array : 'a t -> 'a array
val to_list : 'a t -> 'a list

val iter : ('a -> unit) -> 'a t -> unit
val iteri : (int -> 'a -> unit) -> 'a t -> unit

val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b t -> 'a
val fold_right : ('a -> 'b -> 'b) -> 'a t -> 'b -> 'b

