
open Format
open Puzzle

let file = ref None
let () = 
  Arg.parse ["-p", Arg.String (fun _ -> ()), ""]
    (fun f -> file := Some f) "check [-p file.data] file.sol"
let file = match !file with
  | None -> eprintf "print  [-p file.data] file.sol"; exit 1 
  | Some f -> f

let sol = load file

let ofile = file ^ ".tex"
let cout = open_out ofile
let () = at_exit (fun () -> close_out cout)
let fmt = formatter_of_out_channel cout

let () = fprintf fmt "
\\documentclass{article}
\\begin{document}
\\begin{tabular}{|c|c|c|c|c|c|c|c|c|c|c|c|c|c|c|c|}
\\hline
@."

let () =
  for i = n-1 downto 0 do
    for j = 0 to n-1 do
      let p = sol.(i).(j) in
      if is_real_piece p then fprintf fmt "%d" p.id;
      if j < n-1 then fprintf fmt "&" else fprintf fmt "\\\\\\hline"
    done
  done

let () = fprintf fmt "
\\end{tabular}
\\end{document}@."

let () = ignore (Sys.command (sprintf "latex %s" ofile))
