
(* reads the puzzle from [file] if [-p file] specified on the command line,
   and from standard input otherwise *)

val n : int

val n2 : int

val is_eternity_ii : bool

type kind = Corner of int | Edge of int | Other
    (* arg of Corner and Edge gives the correct rotation if placed at (0,0) *)

type tile = private
  { id : int; 
    kind : kind; 
    pats : int array (* right, up, left, down *)
  }

(* (<f>_pat p r) returns pattern at pos f when rotated by r *)

val right_pat : tile -> int -> int
val up_pat : tile -> int -> int
val left_pat : tile -> int -> int
val down_pat : tile -> int -> int

val dummy_tile : tile (* empty slot *)

val is_real_tile : tile -> bool

(* all [n*n] tiles, as read from standard input *)

val tiles : tile array

(* the 4 corners *)

val corners : tile array 

(* the [4*n-8] edges *)

val edges : tile array 

(* the [(n-2)*(n-2)] other tiles *)

val others : tile array

