
#load "graphics.cma";;
#load "puzzle.cmo";;
#load "draw.cmo";;
open Draw;;
open Format;;
open Graphics;;

let () = open_graph " 600x600"

let c = open_out "pieces.txt"
let fmt = formatter_of_out_channel c
let () = fprintf fmt "16@."

let s i r u l d =
  fprintf fmt "%d %d %d %d %d@." i r u l d;
  right 300 300 300 r;
  up 300 300 300 u;
  left 300 300 300 l;
  down 300 300 300 d;
  set_color white; set_line_width 2;
  moveto 0 0; lineto 600 600;
  moveto 0 600; lineto 600 0; set_line_width 1

let b = 0 (* bord *)
let chj = 1 (* chateau_jaune *)
let chb = 2 (* chateau_bleu *)
let chr = 3 (* chateau_rose *)
let ev = 4 (* etoile_violette *)
let eb = 5 (* etoile_bleue *)
let ej = 6 (* etoile_jaune *)
let xv = 7 (* croix_violette *)
let xb = 8 (* croix_bleue *)
let xm = 9 (* croix_marron *)
let cb = 10 (* carre_bleu *)
let cv = 11 (* carre_vert *)
let bi = 12 (* biscuit *)
let f  = 13 (* fleur *)
let tr = 14 (* trefle_rose *)
let tj = 15 (* trefle_jaune *)
let to_ = 16 (* trefle_orange *)
let sr = 17 (* cristal_rose *)
let sb = 18 (* cristal_bleu *)
let so = 19 (* cristal_orange *)
let sh = 20 (* shuriken *)
let d = 21 (* diamand *)
let e = 22 (* ecrou *)

let () = s 33 f to_ d b
let () = s 114 sr tr so sb
let () = s 132 tr chb chj sb
let () = s 1 d sh b b
let () = s 249 chj sr chb cv
let () = s 166 to_ sr tr xv
let () = s 122 cb xv ev sb
let () = s 26 f tj d b
let () = s 127 xv tr cb sb
let () = s 183 to_ ej tr tr
let () = s 75 xm to_ so tj
let () = s 82 eb eb sr tj
let () = s 22 sh chb f b
let () = s 109 so cb xv sb
let () = s 125 xb chb to_ sb
let () = s 138 xm xv xv eb

let () = s 220 cb so xb xm
let () = s 145 sr xm tr eb
let () = s 162 ev tr cb eb
let () = s 130 to_ ev cb sb
let () = s 61 eb xv tj tj
let () = s 9 d so sh b
let () = s 218 chb sr cb xm
let () = s 144 chj chj xv eb
let () = s 242 chj sr to_ ej
let () = s 245 ev xb sr chr
let () = s 153 ej so chr eb
let () = s 233 ev ej ej ej
let () = s 81 eb ej cv tj
let () = s 98 to_ ev xb tj
let () = s 139 so xv xv eb
let () = s 104 xv xb sb sb

let () = s 12 e to_ sh b
let () = s 46 e ev e b
let () = s 136 ev cb xb sb
let () = s 129 xm sr cb sb
let () = s 90 cb sr ev tj
let () = s 251 to_ xb sr sr
let () = s 161 ev xv cb eb
let () = s 37 sh eb e b
let () = s 227 chb chb chr so
let () = s 253 ev cb to_ chb
let () = s 214 ev xm chb xm
let () = s 210 ej so chr xm
let () = s 246 xb cb chj chr
let () = s 164 cb sr xb eb
let () = s 146 chb eb xm eb
let () = s 117 cb xb so sb

let () = s 53 e chr bi b
let () = s 38 bi xm e b
let () = s 30 bi chr d b
let () = s 52 sh xv bi b
let () = s 7 sh xv sh b
let () = s 11 f cv sh b
let () = s 25 sh chj f b
let () = s 20 f cv f b
let () = s 29 d eb d b
let () = s 155 chr chr sr eb
let () = s 206 chj xb chj tr
let () = s 128 chj ej cb sb
let () = s 181 cb so chj xv
let () = s 120 xb to_ cv sb
let () = s 142 xv cv xv eb
let () = s 209 cv to_ so xm

let () = s 13 bi to_ sh b
let () = s 55 bi sr bi b
let () = s 39 bi so e b
let () = s 60 d xb bi b
let () = s 36 e xb d b
let () = s 64 to_ tj eb tj
let () = s 147 xb eb xm eb
let () = s 115 chb chr so sb
let () = s 84 ej eb chb tj
let () = s 241 chj chr to_ ej
let () = s 96 xm chj chj tj
let () = s 15 sh sb f b
let () = s 8 bi xv sh b
let () = s 58 bi cb bi b
let () = s 51 f sb bi b
let () = s 24 sh ev f b

let () = s 59 f chj bi b
let () = s 169 chj ej ej xv
let () = s 67 sb so eb tj
let () = s 126 cv chj to_ sb
let () = s 101 cv chb sb sb
let () = s 243 chb cv cv chr
let () = s 211 cv cb chr xm
let () = s 57 sh cb bi b
let () = s 5 sh tj sh b
let () = s 134 sr so xb sb
let () = s 135 xm sr xb sb
let () = s 123 ej tr ev sb
let () = s 222 xb chj xb xm
let () = s 17 bi tr f b
let () = s 14 e chj sh b
let () = s 43 f cv e b

let () = s 69 to_ xb eb tj
let () = s 10 e chr sh b
let () = s 157 chr xb sr eb
let () = s 254 cb chj cb ev
let () = s 141 chj ej xv eb
let () = s 68 xv ev eb tj
let () = s 40 f ej e b
let () = s 18 bi ej f b
let () = s 113 cb ev xm sb
let () = s 118 chj xm ej sb
let () = s 131 ev xv chj sb
let () = s 182 so chr chj xv
let () = s 143 chb cb xv eb
let () = s 108 cv sr xv sb
let () = s 244 to_ ev cv chr
let () = s 3 d f b b

let () = s 4 f d b b
let () = s 16 d eb f b
let () = s 106 to_ xm xv sb
let () = s 56 d to_ bi b
let () = s 32 d ev d b
let () = s 158 cb chr ev eb
let () = s 70 chr xm xm tj
let () = s 62 chr tr tj tj
let () = s 76 cv tr ej tj
let () = s 150 so xv ej eb
let () = s 27 d tj d b
let () = s 47 e to_ e b
let () = s 100 chj xb xb tj
let () = s 92 cv ej to_ tj
let () = s 35 bi cb d b
let () = s 97 ej sr xb tj

let () = s 223 xb chb so so
let () = s 49 bi tj bi b
let () = s 195 xb chj chb tr
let () = s 66 tr tr eb tj
let () = s 190 ej cb chr tr
let () = s 203 ej chb chj tr
let () = s 119 chb cb chr sb
let () = s 102 cb chb sb sb 
let () = s 204 to_ chb chj tr
let () = s 216 chj xb chb xm
let () = s 248 sr chb sr cv
let () = s 247 xb chj cv cv
let () = s 208 xb ej so xm
let () = s 228 to_ ej sr so
let () = s 187 chr chj ej tr
let () = s 48 e cb e b

let () = s 80 chj cb chr tj
let () = s 168 cv so ej xv
let () = s 77 cv ej ej tj
let () = s 179 cv to_ to_ xv
let () = s 185 chb ej so tr
let () = s 103 ej cb sb sb
let () = s 207 chr xb xm xm
let () = s 196 cv xb chb tr
let () = s 163 so cv xb eb
let () = s 74 cv ev so tj
let () = s 189 ej xm chr tr
let () = s 192 ev cv cv tr
let () = s 191 xm xm cv tr
let () = s 217 cv ej ev xm
let () = s 250 chj cb ev cv
let () = s 85 tr xv chb tj

let () = s 79 xm ev chr tj
let () = s 170 to_ sr chr xv
let () = s 239 xb cv ev ej
let () = s 226 cv ej chr so
let () = s 229 xb chr ev so
let () = s 165 sr xm tr xv
let () = s 235 sr chr sr ej
let () = s 156 chb chr sr eb
let () = s 186 to_ to_ so tr
let () = s 172 so chj chr xv
let () = s 154 cb xb chr eb
let () = s 212 cb xm cv xm
let () = s 221 chj chj xb xm
let () = s 201 to_ chj cb tr
let () = s 159 xv to_ ev eb
let () = s 65 xb eb eb tj

let () = s 71 chb chr xm tj
let () = s 93 sr ej to_ tj
let () = s 88 chj tj ev tj
let () = s 225 cv cb so so
let () = s 111 cv chb tr sb
let () = s 194 so chj chb tr
let () = s 151 xb sr ej eb
let () = s 177 sr tr ev xv
let () = s 200 xm ej to_ tr
let () = s 124 cv ev ev sb
let () = s 86 chb to_ chb tj
let () = s 133 cb tr xb sb
let () = s 202 chr xb cb tr
let () = s 63 xm sb sb tj
let () = s 149 chb cv xm eb
let () = s 175 chj chr sr xv

let () = s 230 to_ cb ev so
let () = s 167 xm xm so xv
let () = s 89 xb xv ev tj
let () = s 171 cb ev chr xv
let () = s 152 so so chr eb
let () = s 176 ej chr chb xv
let () = s 236 ev chr sr ej
let () = s 237 cv chb sr ej
let () = s 238 cb sr chb ej
let () = s 234 sr cb chr ej
let () = s 72 eb tr so tj
let () = s 173 cv cv cv xv
let () = s 180 cb chr cb xv
let () = s 252 chb to_ chb sr
let () = s 205 xm cb chj tr
let () = s 110 chb cv tr sb

let () = s 28 d sb d b
let () = s 21 e sr f b
let () = s 44 d cv e b
let () = s 42 sh cv e b 
let () = s 41 d ej e b
let () = s 34 e to_ d b
let () = s 19 f chr f b
let () = s 50 sh sb bi b
let () = s 31 f cv d b
let () = s 6 f sb sh b
let () = s 23 bi chb f b
let () = s 140 chb xv xv eb
let () = s 73 sr cv so tj
let () = s 215 xb sr chb xm
let () = s 137 chr ev eb eb
let () = s 193 chr so sr tr

let () = s 2 e sh b b
let () = s 107 to_ ej xv sb
let () = s 99 xv chj xb tj
let () = s 54 e sr bi b
let () = s 45 sh sr e b
let () = s 174 ev chb cv xv
let () = s 240 cv chj ev ej
let () = s 83 sr so sr tj
let () = s 199 ev ev ev tr
let () = s 188 chj tr chr tr
let () = s 91 chb so to_ tj
let () = s 95 tr chb to_ tj
let () = s 148 tr xm xm eb
let () = s 178 cb chb to_ xv
let () = s 105 cv sr eb sb
let () = s 184 chr xb xm tr

let () = s 219 sr so chj xm
let () = s 197 xb so ev tr
let () = s 231 ev chb to_ so
let () = s 213 to_ to_ sr xm
let () = s 116 so chb so sb
let () = s 87 ev cb chb tj
let () = s 232 chj chb to_ so
let () = s 256 xb chj xb (to_)
let () = s 78 cb xm chr tj
let () = s 224 chr ev so so
let () = s 112 ej ev xm sb
let () = s 198 to_ ej ev tr
let () = s 255 xb cb xb ev
let () = s 121 xb tr sr sb
let () = s 160 chj chj to_ eb
let () = s 94 chj sr to_ tj

let () = close_out c
