
open Graphics
open Format
open Puzzle
open Board
open Backt

let step = 50
let half = step / 2
let scale = half-1

let () = Draw.open_board step

let draw_tile i j t =
  let x = step + j * step + half in
  let y = step + i * step + half in
  Draw.piece x y scale t

let clear_tile i j =
  let x = step + j * step in
  let y = step + i * step in
  set_color white;
  fill_rect (x+1) (y+1) (step-2) (step-2)

let () = 
  if is_eternity_ii then begin
    draw_tile 7 7 (piece_at initial 7 7);
    draw_tile 2 2 (piece_at initial 2 2)
  end

let todo =
  let s = ref Cells.empty in
  for i = 1 to 2 do
    for j = 4 to 5 do
      s := Cells.add i j !s
    done
  done;
  Cells.remove 2 2 !s

let display b =
  for i = 0 to 15 do
    for j = 0 to 15 do
      let p = piece_at b i j in
      if is_real_piece p then draw_tile i j p else clear_tile i j
    done
  done;
  ignore (read_key ())

let count = ref 0

let () =
  iter
    (fun b -> incr count(*; display b*))
    (fun _ _ _ -> ()) (fun _ _ -> ())
    choose_mincard
    Board.initial
    todo    

let () = printf "%d solutions@." !count
