
open Format
open Puzzle

(* two identical pieces? *)
let identical p1 p2 =
  p1.right == p2.right && p1.up == p2.up && 
  p1.left == p2.left && p1.down == p2.down

let () =
  let triple = ref 0 in
  let double1 = ref 0 in
  let double2 = ref 0 in
  let stat p =
    if p.right == p.up && p.up == p.left then incr triple
    else if p.right == p.up then incr double1 
    else if p.right == p.left then incr double2
  in
  Array.iter 
    (fun p ->
      stat p; stat (rot p); stat (rot (rot p)); stat (rot (rot (rot p)))
    )
    pieces;
  printf "triple = %d double1 = %d double2 = %d@." !triple !double1 !double2


let ht = Hashtbl.create 1000003

let sign p q =
  q.right lor (p.up lsl 5) lor (q.up lsl 10) lor
  (p.left lsl 15) lor (p.down lsl 20) lor (q.down lsl 25)

let pairs a1 a2 =
  Array.iter 
    (fun p1 ->
       Array.iter 
	 (fun p2 ->
	    if p1.id <> p2.id && p1.right == p2.left then 
	      let s = sign p1 p2 in
	      Hashtbl.add ht s p1.right)
	 a2)
    a1

let () =
  pairs others_rot0 others_rot0;
  pairs others_rot0 others_rot1;
  pairs others_rot0 others_rot2;
  pairs others_rot0 others_rot3;
  pairs others_rot1 others_rot0;
  pairs others_rot1 others_rot1;
  pairs others_rot1 others_rot2;
  pairs others_rot1 others_rot3;
  pairs others_rot2 others_rot0;
  pairs others_rot2 others_rot1;
  pairs others_rot2 others_rot2;
  pairs others_rot2 others_rot3;
  pairs others_rot3 others_rot0;
  pairs others_rot3 others_rot1;
  pairs others_rot3 others_rot2;
  pairs others_rot3 others_rot3

let n = Hashtbl.fold (fun _ _ n -> n+1) ht 0
let () = printf "nb = %d@." n

let () = 
  Hashtbl.iter 
    (fun s _ ->
       let l = Hashtbl.find_all ht s in
       let n = List.length l in
       if n > 1 then printf "mult %d@." n)
    ht
			      
